#include "meta.h"

void InitDD(void) {
	DDSCAPS ddscaps; //dd surface capabilities
	PALETTEENTRY palette[SCRCOLORS]; //palette data
	LPDIRECTDRAWPALETTE lpddpal = NULL; //dd palette
	int i; //counter

	lpdd = NULL;
	lpddsPrimary = NULL;
	lpddsBack = NULL;

	if(FAILED(DirectDrawCreate(NULL, &lpdd, NULL))) die("start up DirectDraw (requires DirectX)");

	if(FAILED(IDirectDraw_SetCooperativeLevel(lpdd, hWnd, DDSCL_FULLSCREEN | DDSCL_EXCLUSIVE | DDSCL_ALLOWMODEX))) die("occupy the whole screen");

	if(FAILED(IDirectDraw_SetDisplayMode(lpdd, SCRX, SCRY, SCRBPP))) die("set the display mode");

	ZeroMemory(&ddsd, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
	ddsd.dwBackBufferCount = 1;
	if(FAILED(IDirectDraw_CreateSurface(lpdd, &ddsd, &lpddsPrimary, NULL))) die("create main drawing surface");

	ZeroMemory(&ddscaps, sizeof(DDSCAPS));
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	if(FAILED(IDirectDrawSurface_GetAttachedSurface(lpddsPrimary, &ddscaps, &lpddsBack))) die("create back buffer");

	for(i = 0; i < SCRCOLORS; i++) { //later, the palette will become more complex (or use > 256 colors)
		palette[i].peRed = i;
		palette[i].peGreen = i;
		palette[i].peBlue = i;
	}
	if(FAILED(IDirectDraw_CreatePalette(lpdd, DDPCAPS_8BIT | DDPCAPS_INITIALIZE, palette, &lpddpal, NULL))) die("set psychedelic colour palette");
	if(FAILED(IDirectDrawSurface_SetPalette(lpddsPrimary, lpddpal))) die("engage psychedelic colours");
}

void KillDD(void) {
	if(lpdd) {
		if(lpddsPrimary) {
			IDirectDraw_Release(lpddsPrimary);
			lpddsPrimary = NULL;
		}
		IDirectDraw_Release(lpdd);
		lpdd = NULL;
	}
}
